## biosig 2.5.0

=== Makefile ===
####### Main Makefile for building the various biosig tools ####################
###
###  Copyright (C) 2010-2020 Alois Schloegl <alois.schloegl@gmail.com>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at http://biosig.sf.net/
###
################################################################################

exec_prefix ?= $(prefix)

first :: lib tools

java: lib
	$(MAKE) -C biosig4c++/java

lib:
	$(MAKE) -C biosig4c++ lib

tools: lib
	$(MAKE) -C biosig4c++ tools

mma mathematica: lib
	$(MAKE) -C biosig4c++/mma

mex4m matlab: lib
	$(MAKE) -C biosig4c++/mex mex4m

R: lib
	$(MAKE) -C biosig4c++/R

install ::
	$(MAKE) -C biosig4c++ install
	install -d $(DESTDIR)/usr/local/share/biosig/matlab
	cp -r biosig4matlab/* $(DESTDIR)/usr/local/share/biosig/matlab/
	-rm -rf $(DESTDIR)/usr/local/share/biosig/matlab/maybe-missing

uninstall ::
	$(MAKE) -C biosig4c++ uninstall
	-rm -rf $(DESTDIR)/usr/local/share/biosig

clean ::
	-$(MAKE) -C biosig4c++/mma clean
	$(MAKE) -C biosig4c++ clean
	-rm mexbiosig*.src.tar.gz
	-rm biosig4octave*.src.tar.gz

distclean : clean
        # also configure.ac for list of files
	-rm config.log
	-rm config.status
	rm Makefile biosig4c++/Makefile biosig4c++/*/Makefile \
		biosig4c++/python/setup.py \
		biosig4c++/R/DESCRIPTION

ifneq (:,/usr/bin/java)
ifneq (:,/usr/bin/javac)
first :: lib
	-$(MAKE) -C biosig4c++/java
endif
clean ::
	-$(MAKE) -C biosig4c++/java clean
test ::
	-$(MAKE) -C biosig4c++/java test
endif

ifneq (:,:)
first :: lib
	$(MAKE) -C biosig4c++/mma
install ::
	-$(MAKE) -C biosig4c++/mma install
uninstall ::
	-$(MAKE) -C biosig4c++/mma uninstall
endif

ifneq (:,:)
MATLAB_MEX := $(shell dirname :)/mex
first ::
	$(MAKE) -C biosig4c++/mex mex4m
install ::
	$(MAKE) -C biosig4c++/mex install
uninstall ::
	$(MAKE) -C biosig4c++/mex uninstall
endif

# source package mexbiosig and biosig4octave
first :: biosig4octave
mexbiosig ::
	$(MAKE) -C biosig4c++ mexbiosig
	ln -sf biosig4c++/mex/mexbiosig-2.5.0.src.tar.gz
biosig4octave ::
	$(MAKE) -C biosig4c++ biosig4octave
	ln -sf biosig4c++/mex/biosig4octave-2.5.0.src.tar.gz

ifneq (:,/usr/bin/octave)
ifneq (:,:)
BIOSIG_MEX_DIR = $(DESTDIR)$(shell octave-config -p LOCALOCTFILEDIR)/biosig
BIOSIG_DIR     = $(DESTDIR)$(shell octave-config -p LOCALFCNFILEDIR)/biosig
first ::
	MKOCTFILE=":" $(MAKE) -C biosig4c++/mex mex4o
install ::
	# mexbiosig
	#-/usr/bin/octave --no-gui --eval "pkg install -global biosig4c++/mex/mexbiosig-2.5.0.src.tar.gz"
	# *.mex
	install -d $(BIOSIG_MEX_DIR)
	install biosig4c++/mex/*.mex $(BIOSIG_MEX_DIR)
	# biosig for octave and matlab
	install -d $(BIOSIG_DIR)
	cp -r biosig4matlab/*  $(BIOSIG_DIR)
	-rm -rf $(BIOSIG_DIR)/maybe-missing

uninstall ::
	# mexbiosig
	#-/usr/bin/octave --no-gui --eval "pkg uninstall -global mexbiosig"
	# *.mex
	-rm -rf $(BIOSIG_MEX_DIR)
	# biosig for octave and matlab
	-rm -rf $(BIOSIG_DIR)
endif
endif

ifneq (:,/usr/bin/php)
first ::
	-$(MAKE) -C biosig4c++/php
install ::
	-$(MAKE) -C biosig4c++/php install
clean ::
	-$(MAKE) -C biosig4c++/php clean
endif

ifneq (:,/usr/bin/python3)
first :: python
python ::
	-PYTHON=/usr/bin/python3 $(MAKE) -C biosig4c++/python sdist
	-$(foreach py, $(shell pyversions -i),  PYTHON=$(py) $(MAKE) -C biosig4c++/python build; )
	-$(foreach py, $(shell py3versions -i), PYTHON=$(py) $(MAKE) -C biosig4c++/python build; )
install ::
	-PYTHON=/usr/bin/python3 $(MAKE) -C biosig4c++/python install
	-$(foreach py, $(shell pyversions -i),  PYTHON=$(py) $(MAKE) -C biosig4c++/python install; )
	-$(foreach py, $(shell py3versions -i), PYTHON=$(py) $(MAKE) -C biosig4c++/python install; )
uninstall ::
	-/usr/bin/python3 -m pip uninstall -y Biosig
	-$(foreach py, $(shell pyversions -i),  $(py) -m pip uninstall -y Biosig;)
	-$(foreach py, $(shell py3versions -i), $(py) -m pip uninstall -y Biosig;)
clean ::
	$(MAKE) -C biosig4c++/python clean
endif

ifneq (:,/usr/bin/R)
first ::
	-$(MAKE) -C biosig4c++/R build
install ::
	-$(MAKE) -C biosig4c++/R install
clean ::
	-$(MAKE) -C biosig4c++/R clean
endif

all: first #win32 win64 #sigviewer #win32/sigviewer.exe win64/sigviewer.exe #biosig_client biosig_server mma java tcl perl php ruby #sigviewer

#---- automatic remaking ---------------------------------------------------#
#   https://www.gnu.org/software/autoconf/manual/autoconf-2.69/html_node/Automatic-Remaking.html#Automatic-Remaking
#---------------------------------------------------------------------------#
$(srcdir)/configure: configure.ac aclocal.m4
	autoconf

# autoheader might not change config.h.in, so touch a stamp file.
$(srcdir)/config.h.in: stamp-h.in
$(srcdir)/stamp-h.in: configure.ac aclocal.m4
	autoheader
	echo timestamp > '$(srcdir)/stamp-h.in'

config.h: stamp-h
stamp-h: config.h.in config.status
	./config.status

Makefile: Makefile.in config.status
	./config.status

config.status: configure
	./config.status --recheck

=== biosig4c++/DESCRIPTION ===
Name: BioSig
Version: 2.5.0
Date: 2022-12-27
Author: Alois Schloegl <alois.schloegl@gmail.com>
Maintainer: Alois Schloegl
Title: BioSig
Description: A software library for biomedical signal processing.
Depends: octave (> 4.0.0),
License: GPL version 3 or later
Url: http://biosig.sf.net

=== biosig4c++/Makefile ===
######## Makefile for "BioSig for C/C++" #####################
###
###  Copyright (C) 2006-2020 Alois Schloegl <alois.schloegl@ist.ac.at>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at https://biosig.sourceforge.io/
###
##############################################################

##### Target: GNU/Linux
#
## make && make install    build and install libbiosig, but no other tools.
#             libbiosig is a prerequisite for building all the other tools below.
#
## make save2gdf   - makes converter
## make biosig_fhir   - makes converter for fhir-binary template
## make install_save2gdf   - installs converter
## make install_mma 	installs biosig's sload for Mathematica in $PREFIX/share/biosig/mathematica
## make install_mex 	installs mexbiosig for Matlab in $PREFIX/share/biosig/mex
#
## make mex4o      - makes mexSLOAD, mexSOPEN for Octave (requires Octave-headers)
## make mex4m      - makes mexSLOAD, mexSOPEN for Matlab (requires Matlab, mex -setup must be configured)
## make mexw32     - makes mexSLOAD.mexw32, mexSOPEN.mexw32 (requires that mingw32, gnumex libraries from Matlab/Win32)
## make mexw64     - makes mexSLOAD.mexw64, mexSOPEN.mexw64 (requires that mce-w32, gnumex libraries from Matlab/Win64)
## make mex        - mex4o, mex4m, mexw32, mexw64 combined
## make biosig4java - makes Java interface (experimental)
## make biosig4php - makes PHP interface (experimental)
## make biosig4perl - makes perl interface (experimental)
## make biosig4ruby - makes ruby interface (experimental)
## make biosig4tcl - makes tcl/tk interface (experimental)
##
## make win32 and make win64 are obsolete. save2gdf.exe, and libbiosig.{a,dll} for windows can now be built
## with the mingw-cross-compiler environment (mxe.cc).
##    git clone https://github.com/schloegl/mxe.git
##    make biosig
## should do what you want. Please note, that win32mma does now also rely that libbiosig is built with MXE.
## Make sure that CROSS or CROSS64 is properly defined when running `make`
##
## ???
## make sigviewer  - makes sigviewer

##### Target: Win32
## make win32      - makes save2gdf.exe,libbiosig.lib,libbiosig.dll, for MSWindows, requires MinGW
## make mexw32 mex/mexSLOAD.mexw32   - requires MinGW32 and GNUMEX libraries from Matlab/Win32
## make win32/sigviewer.exe 	- requires sources of SigViewer, and MinGW32 (mex: make suitesparse zlib qt )

##### Target: Win64
## make win64      - makes save2gdf.exe,libbiosig.lib,libbiosig.dll, for MSWindows, requires MinGW
## make mexw64 mex/mexSLOAD.mexw64   - requires MCE-W64 and GNUMEX libraries from Matlab/Win64
## make win64/sigviewer.exe 	- requires sources of SigViewer and MCE-W64, make suitesparse zlib qt

##### Target: MacOSX w/ homebrew
## make install_homebrew	installs libbiosig and save2gdf
	# requires: brew tap homebrew/dupes
	#	    brew install libiconv

###############################
# whether dynamic or static linking is used, can be controlled with
# LIBEXT. Setting it to 'a' links statically, 'so' links dynamically
#
LIBEXT        = a
#LIBEXT	      = so
###############################

### User-specified options: its likely you want to change this
# settings for cross compiler: tested with MXE and mce-w64 with make suitesparse zlib qt ;
CROSS   = $(HOME)/src/mxe.github.schloegl/usr/bin/i686-w64-mingw32.static
## local MXE
ifeq "$(wildcard $(CROSS)-gcc)" ""
CROSS   = $(HOME)/src/mxe.master/usr/bin/i686-w64-mingw32.static
endif
ifeq "$(wildcard $(CROSS)-gcc)" ""
CROSS         = $(shell pwd)/../mxe/usr/bin/i686-w64-mingw32.static
endif
ifeq "$(wildcard $(CROSS)-gcc)" ""
CROSS         = /usr/local/src/mxe/usr/bin/i686-w64-mingw32.static
endif

CROSS64       = $(HOME)/src/mxe.github.schloegl/usr/bin/x86_64-w64-mingw32.static
ifeq "$(wildcard $(CROSS64)-gcc)" ""
CROSS64       = $(HOME)/src/mxe.master/usr/bin/x86_64-w64-mingw32.static
endif
ifeq "$(wildcard $(CROSS64)-gcc)" ""
CROSS64       = $(HOME)/src/mxe.master/usr/bin/x86_64-w64-mingw32.static
endif

# settings for mex files
MEX_OPTION    = -largeArrayDims # turn on for 64 bit Matlab, otherwise empty
# directory for sources of sigviewer
PathToSigViewer = ../sigviewer
PathToSigViewerWIN32 = ../sigviewer4win32
PathToSigViewerWIN64 = ../sigviewer4win64

CFLAGS       += -pipe -fPIC -fno-builtin-memcmp -O2 -Wno-unused-result
CFLAGS       += -Wno-deprecated
CFLAGS       += -fvisibility=hidden

prefix        = /usr/local
exec_prefix  ?= /usr/local
libdir        = ${exec_prefix}/lib
includedir    = ${prefix}/include
bindir        = ${exec_prefix}/bin
mandir        = ${prefix}/share/man

CFLAGS       += -I$(includedir)
CXXFLAGS     += $(CFLAGS)

## TARGET dependencies
ifeq (,$(TARGET))
	CC      ?= gcc
	CXX     ?= g++
	AR      := ar rcs
	PKGCONF := pkg-config
	SHAREDLIB = -shared
	DLEXT    = so
else ifeq (intel,$(TARGET))
	CC      := icc
	CXX     := icc
	LD      := xild
	AR      := xiar crs
else
	PREFIX  := $(subst /bin/,/,$(dir $(shell which $(TARGET)-gcc)))
	CC      := $(TARGET)-gcc
	CXX     := $(TARGET)-g++
	LD      := $(TARGET)-ld
	AR      := $(TARGET)-ar rcs
	PKGCONF := $(TARGET)-pkg-config
	TARGETPLATFORM = windows
	ifneq (,$(findstring mingw,$(TARGET)))
		## add gnulib's getlogin
		SOURCES += win32/getlogin.c win32/getline.c win32/getdelim.c
		OBJECTS += getlogin.o getline.o getdelim.o
		LDLIBS  += -lssp
		LDLIBS  += -liconv -lstdc++ -lws2_32
		PKG_CONFIG_LIBS += -liconv -lws2_32
		BINEXT   = .exe
		DLEXT    = dll
	endif
endif

SONAMEVERSION ?= 3
DLPRE = lib

### TODO: DLEXT does not work correctly on MXE/MINGW
DLDIR = $(libdir)
ifneq (,$(findstring Darwin, $(shell uname)))
	## Homebrew:
	##	brew install gawk
	##	brew install gnu-tar
	##	brew install homebrew/dupes/libiconv
	##	brew install homebrew/science/suite-sparse
	##
	LD	       = $(CXX) -shared
	CFLAGS        += -I$(prefix)/include
	CFLAGS        += -mmacosx-version-min=10.13
	LDLIBS        += -liconv -lstdc++
	SHAREDLIB      = -dylib -arch x86_64 #-macosx_version_min 10.13
	LDFLAGS       += -L$(prefix)/lib/
	DLEXT          = dylib
	FULLDLEXT      = .dylib
	SONAME_PREFIX  = -install_name # the last space character is crucial

else ifneq (,$(findstring CYGWIN, $(shell uname)))
	DLEXT = dll
	DLPRE = cyg
	DLDIR = $(bindir)
	LIBEXT = dll.a
	BINEXT = .exe
	LD	       = $(CXX)
	LDLIBS        += -liconv -lstdc++
	FULLDLEXT      = -${SONAMEVERSION}.dll
	SONAME_PREFIX  = -Wl,-soname=
	TARGETPLATFORM = windows

else ifneq (,$(findstring MINGW, $(shell uname)))
	### TODO: check if this path is useful at all ###
	## add gnulib's getlogin
	SOURCES += win32/getlogin.c win32/getline.c win32/getdelim.c
	OBJECTS += getlogin.o getline.o getdelim.o
	## exclude conflicting definition of sopen from mingw's io.h
	CC  = gcc
	CXX = g++
	CFLAGS  += -pipe -fPIC -D_REENTRANT -D=BUILD_DLL
	LD	 = $(CXX)
	FULLDLEXT      = ${SONAMEVERSION}.dll
	SONAME_PREFIX  = -Wl,-soname=
	LDLIBS  += -lstdc++
	LDLIBS  += -liconv -lws2_32
	LDFLAGS += -Wl,-subsystem,windows
	LDFLAGS += -L$(prefix)/lib/
	DLDIR = $(bindir)
	TARGETPLATFORM = windows

else ifneq (,$(findstring MSYS_NT,$(shell uname)))
	LD             = $(CXX)
	LDLIBS        += -liconv
	FULLDLEXT      = .so.${SONAMEVERSION}
	SONAME_PREFIX  = -Wl,-soname=

else ifneq (,$(findstring mingw,$(TARGET)))
	## mingw, MXE
	LD	       = $(CXX)
	FULLDLEXT      = -${SONAMEVERSION}.dll
	DLEXT          = dll
	DLDIR = $(bindir)
	TARGETPLATFORM = windows
	SONAME_PREFIX  = -Wl,-soname=

else
	LD	       = $(CXX)
	FULLDLEXT      = .so.${SONAMEVERSION}
	SONAME_PREFIX  = -Wl,-soname=
endif

DEFINES_ALL   = #-D=NDEBUG

DEFINES      += $(DEFINES_ALL)
#DEFINES      += -D=WITH_SON
#DEFINES      += -D=WITHOUT_SCP_DECODE
#DEFINES      += -D=WITH_TIMESTAMPEVENT
#DEFINES      += -D=WITH_TIMESTAMPCHANNEL
### Mingw,MXE, etc. must avoid name space conflict concerning SOPEN ###
#DEFINES      += -D=NO_OLDNAMES

#DEFINES      += -D=WITH_CURL
DEFINES      += -D=__4HAERTEL__
DEFINES      += -D=WITH_FAMOS
DEFINES      += -D=WITH_FIFF
DEFINES      += -D=WITHOUT_NETWORK
DEFINES      += -D=WITH_SCP3
DEFINES      += -D=WITH_FEF
#DEFINES      += -D=WITH_PDP
	### DICOM: DCMTK or GDCM, or internal
	# WITH_DCMTK is already configured by autoconf
	# WITH_GDCM is experimental
	# WITH_DICOM (internal implementation) is experimental
#DEFINES      += -D=WITH_GDCM
#DEFINES      += -D=WITH_GSL
#DEFINES      += -D=WITH_EEPROBE
#DEFINES      += -D=WITH_TDMS
#DEFINES      += -D=WITH_AVI
#DEFINES      += -D=WITH_RIFF
#DEFINES      += -D=WITH_WAV
#DEFINES      += -D=WITH_NEV
DEFINES      += -D=MAKE_EDFLIB

ifeq (1,1)
	LDLIBS     += -lz
endif
ifeq (1,@HAVE_LIBPTHREAD@)
	LDLIBS     += -lpthread
endif
ifeq (1,1)
	LDLIBS     += -lcholmod
	ifeq (Darwin,$(shell uname))
	  ## homebrew requires this in addition to cholmod
	  LDLIBS     += -lsuitesparseconfig
	endif
endif
ifeq (1,1)
	DEFINES      += -D=WITH_DCMTK
	LDLIBS       += -ldcmdata -loflog -lofstd
	SOURCES      += t210/sopen_dcmtk_read.cpp
	OBJECTS      += sopen_dcmtk_read.o
	MinGWOBJECTS += win32/sopen_dcmtk_read.obj
endif
ifeq (1,@HAVE_LIBHDF5@)
	DEFINES    += -DWITH_HDF5=1
	LDLIBS     += -lhdf5 -lhdf5_hl
endif
ifeq (1,@HAVE_LIBMATIO@)
	DEFINES    += -DWITH_MATIO=1
	LDLIBS     += -lmatio
endif
ifeq (1,1)
	LDLIBS     += -lm
endif
ifeq (1,@HAVE_SQLITE3@)
	DEFINES    += -DWITH_SQLITE3=1 -DSQLITE_THREADSAFE=0 -DSQLITE_OMIT_LOAD_EXTENSION
	LDLIBS     += -lsqlite3
endif
ifeq (1,1)
	DEFINES    += -D=WITH_LIBTINYXML
	LDLIBS     += -ltinyxml
endif
ifeq (1,@HAVE_LIBTINYXML2@)
	DEFINES    += -D=WITH_LIBTINYXML2
	LDLIBS     += -ltinyxml2
endif

ifneq (,$(findstring WITH_GDCM, $(DEFINES)))
  INCPATH    += -I$(wildcard /usr/include/gdcm-2*/)
  LDLIBS     += -lgdcmCommon -lgdcmDSED -lgdcmMEXD -lgdcmMSFF -lgdcmDICT -lgdcmIOD
endif

ifneq (,$(findstring WITH_CURL, $(DEFINES)))
  LDLIBS     += -lcurl
endif
ifneq (,$(findstring stack-protector, $(CFLAGS)))
ifneq (,$(findstring CYGWIN, $(shell uname)))
  LDLIBS     += -lssp
endif
ifneq (,$(findstring MINGW, $(shell uname)))
  LDLIBS     += -lssp
endif
endif

DELETE        = rm -f
COPY          = cp -f
DATA_DIR      = data/
DATA_DIR_CFS  = $(HOME)/L/data/test/cfs/
TEMP_DIR      = test/
SED           = sed
TAR           = tar
VERBOSE	     := -V0

##########################################################
## set Matlab and Octave variables
ifeq (undefined,$(origin MATLABDIR))
  ifeq (Darwin,$(shell uname))
    MATLABDIR := $(shell find /Applications/MATLAB* -name bin -type d -depth 1 2>/dev/null | head -1)
  else
    MATLABDIR ?= $(shell find /usr/local/MATLAB* -maxdepth 2 -name bin -type d 2>/dev/null | head -1)
  endif
endif

ifeq (,$(MATLABDIR))
  #$(warning MATLABDIR is not defined)
else
  MEX         = $(MATLABDIR)/mex
  MEX_EXT    := $(shell $(MATLABDIR)/mexext)
endif

##########################################################

##########################################################
## set variables for MinGW Crosscompiler: compile on linux binaries for windows
##
PathToMinGW   = $(dir $(CROSS))..$(nondir $(CROSS))
PathToMinGW64 = $(dir $(CROSS64))..$(nondir $(CROSS64))

MinGWCC      = $(CROSS)-gcc
MinGWCXX     = $(CROSS)-g++
MinGWDEF     = $(DEFINES)
MinGWCFLAGS  = -pipe -fPIC  -D_REENTRANT -D=BUILD_DLL $(MinGWDEF) -Iwin32 -I$(PathToMinGW)/include/
MinGWLIBS    = win32/libbiosig.a -L$(PathToMinGW)/lib/ $(LDLIBS) # static
MinGWLINK    = $(MinGWCXX)

MinGW64CC      = $(CROSS64)-gcc
MinGW64CXX     = $(CROSS64)-g++
MinGW64CFLAGS  = -pipe -fPIC -O2 -D_REENTRANT -D=BUILD_DLL $(MinGWDEF) -Iwin64 -I$(PathToMinGW64)/include/
MinGW64LIBS    = win64/libbiosig.a -L$(PathToMinGW64)/lib/ $(LDLIBS) # static
MinGW64LINK    = $(MinGW64CXX)
##########################################################

# Versioning
MAJOR_VERSION  := $(word 3, $(shell grep '\#define BIOSIG_VERSION_MAJOR' biosig-dev.h))
MINOR_VERSION  := $(word 3, $(shell grep '\#define BIOSIG_VERSION_MINOR' biosig-dev.h))
STEPPING       := $(word 3, $(shell grep '\#define BIOSIG_PATCHLEVEL' biosig-dev.h))
BIOSIG_VERSION := 2.5.0
TODAY          := $(shell date +%Y%m%d)

####### Output directory

=== biosig4c++/R/DESCRIPTION ===
Package: biosig
Version: 2.5.0
Date: 2020-08-22
Encoding: UTF-8
Title: Biomedical Signal Tools
Authors@R: person("Alois", "Schlögl", role = c("aut", "cre"),
                     email = "alois.schloegl@gmail.com", comment="https://orcid.org/0000-0002-5621-8100")
Author: Alois Schlögl [aut, cre]
Maintainer: Alois Schlögl <alois.schloegl@gmail.com>
Depends: R (>= 3.1.0)
Suggests: 
Description: Import filter for about 50 different biomedical signals data formats.
License: GPL (>= 3)
URL: https://biosig.sourceforge.io, http://pub.ist.ac.at/~schloegl
BugReports: https://sourceforge.net/projects/biosig/support

=== biosig4c++/R/Makefile ===

BIOSIG4R_PKG = biosig_2.5.0.tar.gz

build: $(BIOSIG4R_PKG)

sload.so: sload.c
	R CMD SHLIB sload.c -I.. -L.. -lbiosig

clean:
	rm *.o *.so *.gz $(BIOSIG4R_PKG)

$(BIOSIG4R_PKG):
	R CMD build .
	R CMD check --as-cran $@

install: $(BIOSIG4R_PKG)
	R CMD INSTALL $<

=== biosig4c++/igor/Makefile ===
# Makefile for XOP interface to Igor 
# This is experimental for testing the use of MinGW for XOP's
#
# Copyright 2010 A. Schloegl


# configure your cross-compiler and path to IGOR XOP toolkit 
CROSS      = i586-mingw32msvc-
CROSS      = $(HOME)/src/mingw-cross-env/usr/bin/i686-pc-mingw32-

# define path to XOP toolkit
#IGORDIR    = $(HOME)/.wine/drive_c/Program\ Files/WaveMetrics/XOP\ Toolkit\ 6/IgorXOPs6
IGORDIR     = $(HOME)/.wine/drive_c/Program\ Files/WaveMetrics/XOP\ Toolkit\ 5/IgorXOPs5

##### start of Makefile:  

XOP1	    = $(IGORDIR)/XOP1/XOP1.c
GBDIR	    = $(IGORDIR)/GBLoadWave

INCDIR      = -I$(IGORDIR)/XOPSupport/
INCDIR     += -I$(IGORDIR)/XOP1/
INCDIR     += -I$(IGORDIR)/GBLoadWave/
INCDIR     += -I.

LIBS	   += $(IGORDIR)/XOPSupport/VC6/XOPSupport.lib
LIBS	   += ../win32/libbiosig.a ../win32/zlib/lib/libz.a -lws2_32  
LIBS	   += -lversion -lmsvcrt -lcomdlg32

CC	   = g++
DEFINES	   = -D=WINIGOR -D=_WINDOWS_
 
all:XOP1.xop XOPas.xop GBLoadWave.xop


GBLoadWaveres.o: $(GBDIR)/GBLoadWave.rc  
	$(CROSS)windres $(DEFINES) $(INCDIR) $(GBDIR)/GBLoadWave.rc -o GBLoadWaveres.o
GBLoadWave.o: $(GBDIR)/GBLoadWave.c  
	$(CROSS)$(CC) -shared -c -o GBLoadWave.o $(DEFINES) $(INCDIR) -I./$(GBDIR)/ $(GBDIR)/GBLoadWave.c   
GBLoadWaveDialog.o: $(GBDIR)/GBLoadWaveDialog.c  
	$(CROSS)$(CC) -shared -c -o GBLoadWaveDialog.o $(DEFINES) $(INCDIR) -I./$(GBDIR)/ $(GBDIR)/GBLoadWaveDialog.c   
GBLoadWaveOperation.o: $(GBDIR)/GBLoadWaveOperation.c
	$(CROSS)$(CC) -shared -c -o GBLoadWaveOperation.o $(DEFINES) $(INCDIR) -I./$(GBDIR)/ $(GBDIR)/GBLoadWaveOperation.c   
GBScalingDialog.o: $(GBDIR)/GBScalingDialog.c  
	$(CROSS)$(CC) -shared -c -o GBScalingDialog.o $(DEFINES) $(INCDIR) -I./$(GBDIR)/ $(GBDIR)/GBScalingDialog.c   
GBLoadWaveDialog.o: $(GBDIR)/GBLoadWaveDialog.c  
	$(CROSS)$(CC) -shared -c -o GBLoadWaveDialog.o $(DEFINES) $(INCDIR) -I./$(GBDIR)/ $(GBDIR)/GBLoadWaveDialog.c   
GBLoadWave.xop: GBLoadWave.o GBLoadWaveres.o GBLoadWaveOperation.o GBLoadWaveDialog.o GBScalingDialog.o XOPDialogsWin.o libIgor.a XOPSupport.o XOPFiles.o
	$(CROSS)$(CC) -shared -o GBLoadWave.xop GBLoadWave.o GBLoadWaveOperation.o GBLoadWaveDialog.o GBScalingDialog.o XOPDialogsWin.o GBLoadWaveres.o XOPSupport.o XOPFiles.o $(LIBS) libIgor.a  

	
xopSLOAD.o:xopSLOAD.c
	$(CROSS)$(CC) $(DEFINES) $(INCDIR) xopSLOAD.c -o xopSLOAD.o  -c 
#xopSLOAD.xop:libIgor.a XOPSupport.o 
#	$(CROSS)$(CC) -shared -o xopSLOAD.xop $(DEFINES) $(INCDIR) xopSLOAD.c XOPSupport.o $(LIBS) libIgor.a  
xopSLOAD.xop: xopSLOAD.o libIgor.a XOPSupport.o 
	$(CROSS)$(CC) -shared -o xopSLOAD.xop xopSLOAD.o XOPSupport.o $(LIBS) libIgor.a  

	
libIgor.a: $(IGORDIR)/XOPSupport/IGOR.lib
	$(CROSS)reimp -c --as $(CROSS)as --dlltool $(CROSS)dlltool $(IGORDIR)/XOPSupport/IGOR.lib

XOPDialogsWin.o:$(IGORDIR)/XOPSupport/XOPDialogsWin.c
	$(CROSS)$(CC) $(DEFINES) $(INCDIR) $(IGORDIR)/XOPSupport/XOPDialogsWin.c -o XOPDialogsWin.o -c
XOPSupport.o:$(IGORDIR)/XOPSupport/XOPSupport.c
	$(CROSS)$(CC) $(DEFINES) $(INCDIR) $(IGORDIR)/XOPSupport/XOPSupport.c -o XOPSupport.o -c
XOPFiles.o:$(IGORDIR)/XOPSupport/XOPFiles.c
	$(CROSS)$(CC) $(DEFINES) $(INCDIR) $(IGORDIR)/XOPSupport/XOPFiles.c -o XOPFiles.o -c


## compiling XOP1: this should work
XOP1res.o:$(IGORDIR)/XOP1/XOP1.rc
	$(CROSS)windres $(DEFINES) $(INCDIR) $(IGORDIR)/XOP1/XOP1.rc -o XOP1res.o
XOP1.xop: XOPSupport.o libIgor.a XOP1res.o 
	$(CROSS)$(CC) -shared -o XOP1.xop  $(DEFINES) $(INCDIR) $(XOP1) XOP1res.o XOPSupport.o $(LIBS) libIgor.a 


## testing a modified XOP1
XOPasres.o:XOPas.rc
	$(CROSS)windres $(DEFINES) $(INCDIR) XOPas.rc -o XOPasres.o
XOPas.o:XOPas.c
	$(CROSS)$(CC) $(DEFINES) $(INCDIR) XOPas.c -o XOPas.o -c
XOPas.xop:XOPas.o XOPSupport.o libIgor.a  XOPasres.o
	$(CROSS)$(CC) -shared -o XOPas.xop XOPas.o XOPasres.o XOPSupport.o $(LIBS) libIgor.a 


clean:
	rm *.o *.xop *.exe

=== biosig4c++/mex/Makefile ===
####### Makefile for "BioSig for C/C++" #####################
###
###  Copyright (C) 2006-2020 Alois Schloegl <alois.schloegl@ist.ac.at>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at http://biosig.sf.net/
###
##############################################################

##### Target: GNU/Linux
#
## make && make install    build and install libbiosig, but no other tools.
#             libbiosig is a prerequisite for building all the other tools below.
#
## make save2gdf   - makes converter
## make install_save2gdf   - installs converter
#
## make mex4o      - makes mexSLOAD, mexSOPEN for Octave (requires Octave-headers)
## make mex4m      - makes mexSLOAD, mexSOPEN for Matlab (requires Matlab, mex -setup must be configured)
## make mexw32     - makes mexSLOAD.mexw32, mexSOPEN.mexw32 (requires that mingw32, gnumex libraries from Matlab/Win32)
## make mexw64     - makes mexSLOAD.mexw64, mexSOPEN.mexw64 (requires that mce-w32, gnumex libraries from Matlab/Win64)
## make mex        - mex4o, mex4m, mexw32, mexw64 combined
## make biosig4python - makes python interface (requires Python)
## make biosig4java - makes Java interface (experimental)
## make biosig4php - makes PHP interface (experimental)
## make biosig4perl - makes perl interface (experimental)
## make biosig4ruby - makes ruby interface (experimental)
## make biosig4tcl - makes tcl/tk interface (experimental)
##
## make win32 and make win64 are obsolete. save2gdf.exe, and libbiosig.{a,dll} for windows can now be built
## with the mingw-cross-compiler environment (mxe.cc).
##    git clone https://github.com/schloegl/mxe.git
##    make biosig
## should do what you want. Please note, that win32mma does now also rely that libbiosig is built with MXE.
## Make sure that CROSS or CROSS64 is properly defined when running `make`
##
## ???
## make sigviewer  - makes sigviewer

##### Target: Win32
## make win32      - makes save2gdf.exe,libbiosig.lib,libbiosig.dll, for MSWindows, requires MinGW
## make mexw32 mex/mexSLOAD.mexw32   - requires MinGW32 and GNUMEX libraries from Matlab/Win32
## make win32/sigviewer.exe 	- requires sources of SigViewer, and MinGW32 (mex: make suitesparse zlib qt )

##### Target: Win64
## make win64      - makes save2gdf.exe,libbiosig.lib,libbiosig.dll, for MSWindows, requires MinGW
## make mexw64 mex/mexSLOAD.mexw64   - requires MCE-W64 and GNUMEX libraries from Matlab/Win64
## make win64/sigviewer.exe 	- requires sources of SigViewer and MCE-W64, make suitesparse zlib qt 

##### Target: MacOSX w/ homebrew
## make install_homebrew	installs libbiosig and save2gdf
	# requires: brew tap homebrew/dupes
	#	    brew install libiconv

###############################
# whether dynamic or static linking is used, can be controlled with
# LIBEXT. Setting it to 'a' links statically, 'so' links dynamically
#
LIBEXT        = a
#LIBEXT	      = so
###############################


## TARGET dependencies
ifeq (,$(TARGET))
	CC      ?= gcc
	CXX     ?= g++
	AR      := ar rcs
	PKGCONF := pkg-config
ifneq (Darwin,$(shell uname))
	LFLAGS  += -Wl,-z,relro,-z,now
endif
else ifeq (intel,$(TARGET))
	CC      := /opt/intel/bin/icc
	CXX     := /opt/intel/bin/icc
	LD      := /opt/intel/bin/xild
	AR      := /opt/intel/bin/xiar crs
else 
	prefix  := $(dir $(shell which $(TARGET)-gcc))
	CC      := $(TARGET)-gcc
	CXX     := $(TARGET)-g++
	LD      := $(TARGET)-ld
	AR      := $(TARGET)-ar rcs
	PKGCONF := $(TARGET)-pkg-config
	ifeq (mingw, $(findstring mingw, $(TARGET)))
		## add gnulib's getlogin
		SOURCES += win32/getlogin.c win32/getline.c win32/getdelim.c
		OBJECTS += getlogin.o getline.o getdelim.o
		## exclude conflicting definition of sopen from mingw's io.h
		CFLAGS  += -I.
		IO_H_FILE2 = io.h
		CFLAGS  += -I$(prefix)/include
		LIBS    += -lssp
		LDLIBS  += -liconv -lws2_32
	endif
endif

ifeq (Darwin,$(shell uname))
	## Homebrew:
	##	brew tap homebrew/dupes
	##	brew install libiconv
	##
	LD	       = ld
	CFLAGS        += -I/usr/local/opt/libiconv/include
	LDLIBS        += -L/usr/local/opt/libiconv/lib/ -liconv -lstdc++
	LDFLAGS        += -dylib -arch x86_64 -macosx_version_min 10.9
	DLEXT          = dylib
	FULLDLEXT      = ${BIOSIG_VERSION}.dylib
	SONAME_PREFIX  = -install_name # the last space character is crucial
	SONAME_POSTFIX = .${MAJOR_VERSION}.${MINOR_VERSION}.$(DLEXT)
else
	LD	       = $(CXX)
	LDFLAGS       += -shared
	DLEXT          = so
	FULLDLEXT      = so.${BIOSIG_VERSION}
	SONAME_PREFIX  = -Wl,-soname=
	SONAME_POSTFIX = .$(DLEXT).${MAJOR_VERSION}.${MINOR_VERSION}
endif

exec_prefix ?= /usr/local

DEFINES_ALL   = #-D=NDEBUG

LIBS         += $(LDLIBS)

DELETE        = rm -f
COPY          = cp -f
DATA_DIR      = data/
DATA_DIR_CFS  = $(HOME)/L/data/test/CFS/
TEMP_DIR      = test/
VERBOSE	     := -V0

##########################################################
## set Matlab and Octave variables
MATLABDIR ?= $(shell dirname :)

ifeq (.,$(MATLABDIR))
  #$(warning MATLABDIR is not defined)
else
  MEX         = $(MATLABDIR)/mex
  MEX_EXT    := $(shell $(MATLABDIR)/mexext)
endif
##########################################################

first: mex4o 

### Install mexbiosig for Matlab and Octave
install:
	mkdir -p $(DESTDIR)$(exec_prefix)/libexec/biosig/matlab
	install *.mex*   $(DESTDIR)$(exec_prefix)/libexec/biosig/matlab
	@echo "  mexBiosig for Matlab is installed in $(exec_prefix)/libexec/biosig/matlab";
	@echo "  Usage: Start Matlab and addpath ";
	@echo " addpath('$(exec_prefix)/libexec/biosig/matlab')";
	@echo " mexSLOAD";

uninstall:
	# from older source installations
	-${RM} $(DESTDIR)${prefix}/share/biosig/mex/*
	-cd $(DESTDIR)${prefix}/share && rmdir -p biosig
	# from later than 2.0.6 installations
	-${RM} $(DESTDIR)$(exec_prefix)/libexec/biosig/matlab/{mexSLOAD,mexSOPEN,mexSSAVE,physicalunits,accovf_mex}.mex*
	-cd $(DESTDIR)$(exec_prefix)/libexec && rmdir -p biosig/matlab

#############################################################
#	Compilation: Implicit, default rules
#############################################################


#############################################################
#	MEX-files for Octave and Matlab
#############################################################

# include directory for Win32-Matlab include
W32MAT_INC = $(HOME)/bin/win32/Matlab/R2010b/extern/include/ -I../win32
W64MAT_INC = $(HOME)/bin/win64/Matlab/R2010b/extern/include/ -I../win64
# path to GNUMEX libraries, available from here http://sourceforge.net/projects/gnumex/
GNUMEX   = $(HOME)/bin/win32/gnumex
GNUMEX64 = $(HOME)/bin/win64/gnumex

mexSOPEN.cpp : mexSLOAD.cpp
	echo "#define mexSOPEN" > mexSOPEN.cpp
	cat mexSLOAD.cpp >> mexSOPEN.cpp

MEX_OBJECTS = mexSLOAD.cpp mexSOPEN.cpp mexSSAVE.cpp physicalunits.cpp accovf_mex.cpp

mex4o:  $(patsubst %.cpp, %.mex, $(MEX_OBJECTS))
oct:    $(patsubst %.cpp, %.oct, $(MEX_OBJECTS))
mexw32: $(patsubst %.cpp, %.mexw32, $(MEX_OBJECTS))
mexw64: $(patsubst %.cpp, %.mexw64, $(MEX_OBJECTS))

ifdef MEX_EXT
mex: mex4o mex4m mexw32 mexw64
mex4m: $(patsubst %.cpp, %.$(MEX_EXT), $(MEX_OBJECTS))

%.$(MEX_EXT): %.cpp
	$(MEX) $(MEX_OPTION) $(DEFINES) -I.. "$<" -L.. -lbiosig -output "$@"

else
mex: mex4o mexw32 mexw64
endif

ifneq (:,/usr/bin/octave)
%.mex: %.cpp
	$(MKOCTFILE) $(DEFINES) -I.. -v -g --mex "$<" -L.. -lbiosig -o "$@"

%.oct: %.cpp
	$(MKOCTFILE) $(DEFINES) -I.. "$<" -L.. -lbiosig -o "$@"
endif

%.mexw32: %.cpp
	## $(CROSS)-g++ is used instead of $(CXX), so it can be called from biosig as well as mxe. 
	$(CROSS)-g++ -shared $(GNUMEX)/mex.def -DMATLAB_MEX_FILE $(DEFINES) -x c++ \
		-I$(prefix)/include \
		-I$(W32MAT_INC) -O2 -o "$@" -L$(GNUMEX) -s "$<" -llibmx -llibmex $(shell $(CROSS)-pkg-config --libs libbiosig)

%.mexw64: %.cpp
	$(CROSS64)-g++ -shared $(GNUMEX64)/mex.def -DMATLAB_MEX_FILE $(DEFINES) -x c++ \
		-I$(prefix)/include \
		-I$(W64MAT_INC) -O2 -o "$@" -L$(GNUMEX64) -s "$<" -llibmx -llibmex $(shell $(CROSS64)-pkg-config --libs libbiosig)

clean:
	-$(DELETE) *.o *.obj *.o64 core octave-core *.oct *.mex* mexSOPEN.cpp

=== biosig4c++/mma/Makefile ===
####### Makefile to compile biosig.exe for loading data supported by libbiosig into Mathematica
###
###  Copyright (C) 2010-2020 Alois Schloegl <alois.schloegl@gmail.com>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at http://biosig.sf.net/
###
##############################################################


###########################################
# user-defined variables
###########################################
CROSS   ?= /home/schloegl/src/mxe.github.schloegl/usr/bin/i686-w64-mingw32.static
CROSS64 ?= /home/schloegl/src/mxe.github.schloegl/usr/bin/x86_64-w64-mingw32.static

exec_prefix ?= /usr/local

###########################################
## set Mathematica variables
MATHEMATICA_EXE = :
MATHEMATICA_EXE ?= $(shell which mathematica)
ifeq (,$(MATHEMATICA_EXE))
        $(error "mathematica not found in $$PATH - cannot compile biosig for Mathematica")
endif
MLINKDIR ?= $(realpath $(addsuffix ..,$(dir $(realpath $(MATHEMATICA_EXE) ) ) ) )

ifneq (,$(findstring Darwin,$(shell uname)))
MLINKDIR := /Applications/Mathematica.app/Contents/
SYS       = MacOSX-x86-64
LDFLAGS  += -demangle -dynamic -arch x86_64
LDFLAGS  += -framework CoreFoundation -framework CoreVideo -framework VideoDecodeAcceleration
else
SYS 	  = $(notdir $(shell ls -1d $(MLINKDIR)/SystemFiles/Links/MathLink/DeveloperKit/*))
ifneq (1,$(words ${SYS}))
SYS       = Linux-x86-64# Set this value with the result of evaluating $SystemID
endif
endif

### Windows ###
SYSwin       = Windows# Set this value with the result of evaluating $SystemID
MLLIBwin     = ml32i4m# Set this to ML64i3 if using a 64-bit system
SYSwin64     = Windows-x86-64# Set this value with the result of evaluating $SystemID
MLLIBwin64   = ml64i4# Set this to ML64i3 if using a 64-bit system
###########################################

CADDSDIR  = ${MLINKDIR}/SystemFiles/Links/MathLink/DeveloperKit/${SYS}/CompilerAdditions
INCDIR    = -I${CADDSDIR} -I${MLINKDIR}/SystemFiles/IncludeFiles/C/
LIBDIR   += -L${CADDSDIR}

# automated detection of most recent MLINTERFACE, without starting mathematica
# 10.0 supports 3 and 4, 9.0 and earlier supports only 3,
MLIVER := $(shell ${CC} mliver.c -I${CADDSDIR} -E -o - | tail -1)

EXTRALIBS += -lm -ldl -luuid -lstdc++ # Set these with appropriate libs for your system.

ifeq (Darwin,$(shell uname))
MLLIB   = MLi${MLIVER} # ML32i3 # Set this to ML64i3 if using a 64-bit system
SED	= gsed
else
MLLIB   = ML$(shell getconf LONG_BIT)i${MLIVER} # ML32i3 # Set this to ML64i3 if using a 64-bit system
EXTRALIBS += -lrt
SED	= sed
endif
LD 	= ${CC}


ifneq (${MLIVER},)
CFLAGS += -DMLINTERFACE=${MLIVER}
endif

MPREP     = ${CADDSDIR}/mprep

TARGET    = biosig

# make Linux-x86-64
mma : $(patsubst %, ${SYS}/%.exe, $(TARGET))
# make Linux-x86-64, Windows, Windows-x86-64
all : $(patsubst %, ${SYS}/%.exe, $(TARGET)) $(patsubst %, ${SYSwin}/%.exe, $(TARGET)) $(patsubst %, ${SYSwin64}/%.exe, $(TARGET))

.c.o:
	${CC} ${CFLAGS} -I.. ${INCDIR} -c "$<"

%tm.c: %.tm
	${MPREP} "$<" -o "$@"
	${SED} -i 's# __DATE__# ",__DATE__," ",__TIME__,"#g' "$@"

${SYS}/%.exe: %.o %tm.o
	mkdir -p ${SYS}
	${LD} ${LDFLAGS} $? ${LIBDIR} -l${MLLIB} ${EXTRALIBS} -L.. -lbiosig  -o "$@"
	ln -sf "$@"

### Install Biosig for Mathematica
install : biosig.exe
	mkdir -p $(DESTDIR)$(exec_prefix)/libexec/biosig/mathematica
	install biosig.exe	$(DESTDIR)$(exec_prefix)/libexec/biosig/mathematica/
	@echo "  Biosig for Mathematica is installed in $(exec_prefix)/libexec/biosig/mathematica/biosig.exe";
	@echo "  Usage: Start Mathematica and run";
	@echo "\tlink=Install[\"$(exec_prefix)/libexec/biosig/mathematica/biosig.exe\"];";
	@echo "\t?Sload\n\t?Uload\n";

uninstall:
	${RM} $(DESTDIR)$(datadir)/biosig/mathematica/{sload,biosig}.exe
	-cd $(DESTDIR)$(datadir) && rmdir -p biosig/mathematica
	${RM} $(DESTDIR)$(exec_prefix)/libexec/biosig/mathematica/biosig.exe
	-cd $(DESTDIR)$(exec_prefix)/libexec && rmdir -p biosig/mathematica

###########################################
#   Win32 - cross-compilation
###########################################

CCw32        = $(CROSS)-gcc
CADDSDIRwin  = ${MLINKDIR}/SystemFiles/Links/MathLink/DeveloperKit/${SYSwin}/CompilerAdditions
INCDIRwin    = -I${CADDSDIRwin}
LIBDIRwin    = ${CADDSDIRwin}

EXTRALIBSwin = -lgdi32 -lm -lstdc++ -lws2_32 $(LDLIBS) # Set these with appropriate libs for your system.

MPREPwin     = ${CADDSDIRwin}/mprep.exe

${SYSwin}/%tm.c : %.tm
	mkdir -p ${SYSwin}
	WINEPREFIX=${HOME}/.wine32.mma wine ${MPREPwin} "$<" -o "$@"
	${SED} -i 's# __DATE__# ",__DATE__," ",__TIME__,"#g' "$@"

${SYSwin}/biosigtm.obj : ${SYSwin}/biosigtm.c
	${CCw32} -o "$@" -c "$<" $(shell $(CROSS)-pkg-config --cflags libbiosig) ${INCDIRwin}
${SYSwin}/biosig.obj : biosig.c
	mkdir -p ${SYSwin}
	${CCw32} -o "$@" -c "$<" $(shell $(CROSS)-pkg-config --cflags libbiosig) ${INCDIRwin}
	# ${CCw32} -o "$@" -c "$<" $(shell $(CROSS)-pkg-config --cflags libbiosig) -DWINDOWS_MATHLINK=1 -D__int64="long" ${INCDIR}

win32mma : $(patsubst %, ${SYSwin}/%.exe, $(TARGET))

${SYSwin}/%.exe : ${SYSwin}/%.obj ${SYSwin}/%tm.obj
	${CCw32} $? -mwindows -static-libgcc -static-libstdc++ $(shell $(CROSS)-pkg-config --libs libbiosig) -lssp -L${LIBDIRwin} -l${MLLIBwin} ${EXTRALIBSwin} -o "$@"


###########################################
#   Win64 - cross-compilation
###########################################

CCw64         = $(CROSS64)-gcc
CADDSDIRwin64 = ${MLINKDIR}/SystemFiles/Links/MathLink/DeveloperKit/${SYSwin64}/CompilerAdditions
INCDIRwin64   = -I${CADDSDIRwin64}
LIBDIRwin64   = ${CADDSDIRwin64}

#MPREPwin64    = ${CADDSDIRwin64}/mprep.exe

#%tm.win64.c : %.tm
#	WINEPREFIX=${HOME}/.wine64.mma wine64 ${MPREPwin64} "$<" -o "$@"
	#${MPREP} "$<" -o "$@"
#	${SED}  -i 's# __DATE__# ",__DATE__," ",__TIME__,"#' "$@"

${SYSwin64}/%.obj : %.c
	mkdir -p ${SYSwin64}
	${CCw64} -o "$@" -c "$<" $(shell $(CROSS64)-pkg-config --cflags libbiosig) -DWINDOWS_MATHLINK=1 -D__int64="long long" ${INCDIR}

win64mma : $(patsubst %, ${SYSwin64}/%.exe, $(TARGET))

${SYSwin64}/%.exe : ${SYSwin64}/%.obj ${SYSwin64}/%tm.obj
	${CCw64} $? -static-libgcc -static-libstdc++ $(shell $(CROSS64)-pkg-config --libs libbiosig) -lssp -L${LIBDIRwin64} -l${MLLIBwin64} ${EXTRALIBSwin} -o "$@"


###########################################
clean:
	-$(RM) *.o* */*.o*
	-$(RM) *tm.c */*tm.c
	-$(RM) *.exe */*.exe

=== biosig4c++/python/Makefile ===
####### Makefile for "BioSig for C/C++" #####################
###
###  Copyright (C) 2006-2021 Alois Schloegl <alois.schloegl@ist.ac.at>
###  This file is part of the "BioSig for C/C++" repository 
###  (biosig4c++) at http://biosig.sf.net/ 
###
##############################################################

PYTHON ?= python3
PYVER  := $(shell $(PYTHON) -c "import sys; print(sys.version[:3])")

release target : sdist build

wheel: bdist_wheel

dist/Biosig-2.5.0.tar.gz : sdist

sdist build install bdist_wheel ::
	$(PYTHON) setup.py $@

test:
	## get ../data/Newtest17-256.bdf
	$(MAKE) -C .. fetchdata
	## need to run from different directory, because
	(cd .. && PYTHONPATH=/usr/local/lib/python$(PYVER)/dist-packages/ $(PYTHON) -c 'import biosig; print(biosig.header("data/Newtest17-256.bdf"))')
	(cd .. && PYTHONPATH=/usr/local/lib/python$(PYVER)/dist-packages/ $(PYTHON) -c 'import biosig; print(biosig.data("data/Newtest17-256.bdf"))')
	(cd .. && PYTHONPATH=/usr/local/lib/python$(PYVER)/dist-packages/ $(PYTHON) < python/demo2.py)

clean:
	-rm -rf build/*
	-rm -rf dist/*
	-rm *.so

check: release
	twine check dist/*

=== biosig4c++/ruby/Makefile ===
####### Makefile for "BioSig for C/C++" #####################
###
###  Copyright (C) 2017 Alois Schloegl <alois.schloegl@gmail.com>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at http://biosig.sf.net/
###
##############################################################

# More information on SWIG-Ruby interface is available here
# http://www.swig.org/Doc1.3/Ruby.html


all:
	$(error support for biosig on ruby is not ready yet)
	swig -c++ -ruby biosig.i
	ruby extconf.rb
	$(MAKE)

clean:
	-rm *.cxx
	-rm *.o
	-rm *.pm
	-rm *.so

=== biosig4c++/t240/Makefile ===
-include modules.mk

# This file may be used as an input for make(3)
# Remove the lines below to convert it into a pure .am file
WIN32  = ../win32/libcnsfef.a ../win32/libcnsfef.dll
WIN64  = ../win64/libcnsfef.a ../win64/libcnsfef.dll
CFLAGS += -pipe -fPIC -Wall -O2 -Wextra  -I.
OBJS=${ASN_MODULE_SOURCES:.c=.o}
WINOBJS=${ASN_MODULE_SOURCES:.c=.obj}
W64OBJS=${ASN_MODULE_SOURCES:.c=.o64}

ifeq (Darwin,$(shell uname))
	CFLAGS        += -mmacosx-version-min=10.7
endif

CC ?= gcc
MinGWCC   = $(CROSS)-gcc 
MinGW64CC = $(CROSS64)-gcc 

all: libcnsfef.a $(WIN32)

libcnsfef.a: $(OBJS) 
	$(AR) libcnsfef.a $(OBJS) 

../win32/libcnsfef.a: $(WINOBJS) 
	$(CROSS)-$(AR) ../win32/libcnsfef.a $(WINOBJS) 

../win64/libcnsfef.a: $(W64OBJS) 
	$(CROSS64)-$(AR) ../win64/libcnsfef.a $(W64OBJS) 

../win32/libcnsfef.dll: $(WINOBJS)
	$(MinGWCC) -shared -fPIC  $(WINOBJS)  -Wl,--output-def,../win32/libcnsfef.def,--out-implib,../win32/libcnsfef.dll

../win64/libcnsfef.dll: $(WINOBJS)
	$(MinGW64CC) -shared -fPIC  $(W64OBJS)  -Wl,--output-def,../win64/libcnsfef.def,--out-implib,../win64/libcnsfef.dll


.SUFFIXES:
.SUFFIXES: .c .o

%.obj: %.c
	$(CROSS)-$(CC) $(CFLAGS) -o "$@" -c "$<"
%.o64: %.c
	$(CROSS64)-$(CC) $(CFLAGS) -o "$@" -c "$<"

.c.o:
	$(CC) $(CFLAGS) -o "$@" -c "$<"

clean:
#	rm -f $(ASN_MODULE_HEADERS)
#	rm -f $(ASN_MODULE_SOURCES)
	rm -f libcnsfef.a $(WIN32)
	rm -f $(OBJS)
	rm -f $(WINOBJS)
	rm -f $(W64OBJS)
	rm -f Makefile.am.sample libfef.a 

regen: regenerate-from-asn1-source 

regenerate-from-asn1-source:
	asn1c -fcompound-names fef.asn
	awk '/^#/ {exit} {print}' Makefile.am.sample >modules.mk
	rm -f converter-sample.c Makefile.am.sample libfef.a

=== debian/changelog ===
biosig (2.5.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version (all patches applied upstream)
  * Fix watch file
  * Standards-Version: 4.6.2 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 05 Jan 2023 08:15:48 +0100

=== debian/control ===
Source: biosig
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>,
           Michael Hanke <michael.hanke@gmail.com>,
           Alois Schlögl <alois.schloegl@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-python,
               d-shlibs,
               gawk,
               python3-setuptools,
               python3-all-dev,
               python3-numpy,
               zlib1g-dev,
               libsuitesparse-dev,
               dh-octave,
               libdcmtk-dev,
               libtinyxml-dev,
               libb64-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/biosig
Vcs-Git: https://salsa.debian.org/med-team/biosig.git
Homepage: https://biosig.sourceforge.io/
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-python

Package: libbiosig3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: I/O library for biomedical data - dynamic library
 BioSig is a library for accessing files in several biomedical data formats
 (including EDF, BDF, GDF, BrainVision, BCI2000, CFWB, HL7aECG,
 SCP_ECG (EN1064), MFER, ACQ, CNT(Neuroscan), DEMG, EGI, EEG1100,
 FAMOS, SigmaPLpro, TMS32).  The complete list of supported file
 formats is available at http://pub.ist.ac.at/~schloegl/biosig/TESTED .
 .
 This package provides dynamic library.

Package: libbiosig-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libbiosig3 (= ${binary:Version}),
         ${devlibs:Depends},
         ${misc:Depends}
Description: I/O library for biomedical data - development files
 BioSig is a library for accessing files in several biomedical data formats
 (including EDF, BDF, GDF, BrainVision, BCI2000, CFWB, HL7aECG,
 SCP_ECG (EN1064), MFER, ACQ, CNT(Neuroscan), DEMG, EGI, EEG1100,
 FAMOS, SigmaPLpro, TMS32).  The complete list of supported file
 formats is available at http://pub.ist.ac.at/~schloegl/biosig/TESTED .
 .
 This package provides header files and static library.

Package: biosig-tools
Architecture: any
Depends: libbiosig3 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: format conversion tools for biomedical data formats
 Based on BioSig library, this package provides command line
 tools, such as
 .
  - save2gdf: converter between different file formats, including but
        not limited to SCP-ECG(EN1064), HL7aECG (FDA-XML), GDF, EDF,
        BDF, CWFB.
  - biosig2gdf: converts biosig data files into GDF, to simplify
        parsing and loading by scripting languages (e.g. loadgdf.{py,r})
  - rec2bin, bin2rec, heka2itx, save2aecg, save2scp: several converter
       tools based on save2gdf
  - biosig_fhir: packs biosignal data into HL7/FHIR binary template file.
  - physicalunits: converter for encoding and decoding of physical
       units according to ISO 11073-10101

Package: python3-biosig
Architecture: any
Multi-Arch: same
Section: python
Depends: libbiosig3 (= ${binary:Version}),
         ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends},
Description: Python3 bindings for BioSig library
 This package provides Python3 bindings for BioSig library.  Primary
 goal -- I/O interface to variety of biomedical file formats, including
 but not limited to SCP-ECG(EN1064), HL7aECG (FDA-XML), GDF, EDF.

Package: octave-biosig
Architecture: any
Multi-Arch: same
Depends: libbiosig3 (= ${binary:Version}),
         ${octave:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Description: Octave bindings for BioSig library
 This package provides Octave bindings for BioSig library.  Primary
 goal -- I/O interface to variety of biomedical file formats, including
 but not limited to SCP-ECG(EN1064), HL7aECG (FDA-XML), GDF, EDF.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

MAKEOPTS=LIBEXT=so

export PYBUILD_NAME=biosig
export PYBUILD_DIR=biosig4c++/python/

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh  $@ --with python3,numpy3,octave

override_dh_auto_build:
	dh_auto_build -- $(MAKEOPTS)
	pybuild --build

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	echo "I: skip testing for now -- relies on download of test data"
endif

override_dh_auto_install:
	dh_auto_install
	pybuild --install

override_dh_install:
	dh_install
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --override s/libcholmod3-dev/libsuitesparse-dev/ \
		    --override s/libtinyxml2.6.2-dev/libtinyxml-dev/ \
		    --movedev debian/tmp/usr/include usr \
		    --movedev "debian/tmp/usr/lib/*/pkgconfig/*.pc" usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
		    debian/tmp/usr/lib/*/*.so

# No idea whether octave needs the extra LICENSE file - if so it can be deleted here
#override_dh_installdocs:
#	dh_installdocs
#	find debian -name LICENSE -delete

override_dh_auto_clean:
	if [ -f $(PYBUILD_DIR)/setup.py ] ; then pybuild --clean ; fi
	dh_auto_clean

## biosig 2.6.0

=== biosig4c++/DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Name: BioSig
-Version: 2.5.0
-Date: 2022-12-27
+Version: 2.6.0
+Date: 2024-02-19
 Author: Alois Schloegl <alois.schloegl@gmail.com>
 Maintainer: Alois Schloegl
 Title: BioSig

=== debian/changelog ===
biosig (2.6.0-1ubuntu1) noble; urgency=medium

  * debian/patches: drop use of deprecated numpy.distutils
    (LP: #2060746)

 -- Nick Rosbrook <enr0n@ubuntu.com>  Wed, 10 Apr 2024 11:10:06 -0400

biosig (2.6.0-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:43:37 +0000

biosig (2.6.0-1build1) noble; urgency=high

  * No change rebuild against libdcmtk17t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 16:31:07 +0100

biosig (2.6.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * No need to preserve config.h any more

 -- Andreas Tille <tille@debian.org>  Mon, 19 Feb 2024 09:24:07 +0100

biosig (2.5.2-2) unstable; urgency=medium

  * Team upload.
  * Fix clean target
    Closes: #1043666

 -- Andreas Tille <tille@debian.org>  Tue, 06 Feb 2024 10:54:19 +0100

biosig (2.5.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Cope with missing config.status which is called in clean target

 -- Andreas Tille <tille@debian.org>  Thu, 19 Oct 2023 12:17:53 +0200

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: biosig
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Yaroslav Halchenko <debian@onerussian.com>,
            Michael Hanke <michael.hanke@gmail.com>,
            Alois Schlögl <alois.schloegl@gmail.com>
